## dwarfutils 0.11.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(libdwarf VERSION 0.11.1 
    DESCRIPTION "Library to access DWARF debugging information" 
    HOMEPAGE_URL "https://github.com/davea42/libdwarf-code.git"
    LANGUAGES C CXX)

# libdwarf
option(BUILD_NON_SHARED "build archive library libdwarf[p].a" TRUE)
option(BUILD_SHARED "build shared library libdwarf[p].so and use it" FALSE)

option(ENABLE_DECOMPRESSION
    "Enables support for compressed debug sections if both libz/libzstd are present"
    TRUE)

#  This adds compiler option -Wall (gcc compiler warnings)
option(WALL "Add -Wall" FALSE)
option(LIBDWARF_STATIC "add -DLIBDWARF_STATIC" FALSE)

option(BUILD_DWARFDUMP "Build dwarfdump (default is YES)" TRUE)

option(BUILD_DWARFGEN "Build dwarfgen (default is NO)" FALSE)
message(STATUS "Building dwarfgen    ... ${BUILD_DWARFGEN}")

option(BUILD_DWARFEXAMPLE "Build dwarfexample (default is NO)" FALSE)
message(STATUS "Building dwarfexample... ${BUILD_DWARFEXAMPLE}")

option(DO_TESTING "Do certain api tests (default is NO)" FALSE)
message(STATUS "Building api tests   ... ${DOTESTS}")
### end what was configure.cmake

option(PIC_ALWAYS "Build libdwarf with position-independent code for both static and shared (default is NO)" FALSE)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
include_directories( ${PROJECT_BINARY_DIR} )

# used to compile on MSVC upto 2013 where snprintf is not available
macro(msvc_posix target)
    if(MSVC AND ("${MSVC_VERSION}" LESS 1900))
        # under VS 2015
	target_compile_definitions(${target} PUBLIC
	    snprintf=_snprintf)
    endif()
endmacro()

set(LIBDWARF_CRT "MD" CACHE STRING "Either MT or MD, specifies whether to use the static or dynamic MSVCRT.")

if (CMAKE_CXX_COMPILER_ID STREQUAL "MSVC")
  # Use CMAKE_MSVC_RUNTIME in versions 3.15 and up
  if (CMAKE_VERSION VERSION_GREATER_EQUAL "3.15")
    cmake_policy(SET CMP0091 NEW)
    if (LIBDWARF_CRT STREQUAL "MT")
      message(STATUS "Using MT runtime by CMAKE_MSVC_RUNTIME_LIBRARY")
      set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
    elseif(LIBDWARF_CRT STREQUAL "MD")
      message(STATUS "Using MD runtime by CMAKE_MSVC_RUNTIME_LIBRARY")
      set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
    else()
      message(FATAL_ERROR "LIBDWARF_CRT must be MT or MD")
    endif()
  # Use regexes in versions before 3.15
  else()
    if (LIBDWARF_CRT STREQUAL "MT")
      message(STATUS "Using MT runtime by compile flag replacement")
      # taken from the CMake FAQ
      foreach(flag_v
      CMAKE_C_FLAGS CMAKE_C_FLAGS_DEBUG
      CMAKE_C_FLAGS_RELEASE CMAKE_C_FLAGS_MINSIZEREL
      CMAKE_C_FLAGS_RELWITHDEBINFO
      CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG
      CMAKE_CXX_FLAGS_RELEASE CMAKE_CXX_FLAGS_MINSIZEREL
      CMAKE_CXX_FLAGS_RELWITHDEBINFO)
        if (${flag_v} MATCHES "([\\/\\-]M)D")
          string(REGEX REPLACE "([\\/\\-]M)D" "\\1T"
          ${flag_v} "${${flag_v}}")
        endif()
      endforeach()
    elseif(LIBDWARF_CRT STREQUAL "MD")
      message(STATUS "Using MD runtime by cmake default")
    else()
      message(FATAL_ERROR "LIBDWARF_CRT must be MT or MD")
    endif()
  endif()
endif()

# message("CMake flags are:")
# message("  CMAKE_C_FLAGS: ${CMAKE_C_FLAGS}")
# message("  CMAKE_C_FLAGS_DEBUG: ${CMAKE_C_FLAGS_DEBUG}")
# message("  CMAKE_C_FLAGS_RELEASE: ${CMAKE_C_FLAGS_RELEASE}")
# message("  CMAKE_C_FLAGS_MINSIZEREL: ${CMAKE_C_FLAGS_MINSIZEREL}")
# message("  CMAKE_C_FLAGS_RELWITHDEBINFO: ${CMAKE_C_FLAGS_RELWITHDEBINFO}")
# message("  CMAKE_CXX_FLAGS: ${CMAKE_CXX_FLAGS}")
# message("  CMAKE_CXX_FLAGS_DEBUG: ${CMAKE_CXX_FLAGS_DEBUG}")
# message("  CMAKE_CXX_FLAGS_RELEASE: ${CMAKE_CXX_FLAGS_RELEASE}")
# message("  CMAKE_CXX_FLAGS_MINSIZEREL: ${CMAKE_CXX_FLAGS_MINSIZEREL}")
# message("  CMAKE_CXX_FLAGS_RELWITHDEBINFO: ${CMAKE_CXX_FLAGS_RELWITHDEBINFO}")


# set target folder on IDE
macro(set_folder target folder)
  set_target_properties(${target} PROPERTIES FOLDER ${folder})
endmacro()

# set source groups on IDE
macro(set_source_group list_name group_name)
    set(${list_name} ${ARGN})
    source_group(${group_name} FILES ${ARGN})
endmacro()

# view folders on supported IDEs
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

# tells cmake to look in 64bit first (cmake
# would probably do this anyway).
set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE)

### begin what was configure.cmake
# cmake macros
include(TestBigEndian)
include(CheckIncludeFile)
include(CheckCSourceCompiles)
include(CheckCSourceRuns)
include(CheckSymbolExists)
### Version also appears in configure.ac
set(PACKAGE_BUGREPORT "https://github.com/davea42/libdwarf-code/issues")
set(PACKAGE_STRING "${PROJECT_NAME} ${PROJECT_VERSION}")
string(REGEX REPLACE "[\"]" "" tarname1 "${PACKAGE_STRING}" )
string(REGEX REPLACE "[^a-zA-Z0-9_]" "-" tarname "${tarname1}" )
set(PACKAGE_TARNAME "\"${tarname}\"" )

test_big_endian(isBigEndian)
if (${isBigEndian})
  set ( WORDS_BIGENDIAN 1 )
endif()

check_include_file( "sys/types.h"     HAVE_SYS_TYPES_H)
check_include_file( "sys/stat.h"      HAVE_SYS_STAT_H )
check_include_file( "stdint.h"        HAVE_STDINT_H   )
check_include_file( "unistd.h"        HAVE_UNISTD_H   )
check_include_file( "stdafx.h"        HAVE_STDAFX_H   )
check_include_file( "fcntl.h"         HAVE_FCNTL_H   )

### cmake provides no way to guarantee uint32_t present.
### configure does guarantee that.
if(HAVE_STDINT_H)
  check_c_source_compiles("
  #include <stdint.h>
  int main()
  {
      uintptr_t i; i = 12;
      return (int)i;
  }" HAVE_UINTPTR_T)
  check_c_source_compiles("
  #include <stdint.h>
  int main()
  {
      intptr_t i; i = 12;
      return (int)i;
  }" HAVE_INTPTR_T)
endif()
if (HAVE_UINTPTR_T)
  message(STATUS "HAVE_UINTPTR_T 1: uintptr_t defined in stdint.h... YES")
else()
  message(STATUS "uintptr_t defined in stdint.h... NO")
  set(uintptr_t "unsigned long long int" )
  message(STATUS "Setting #define uintptr_t " ${uintptr_t})
endif()
if (uintptr_t)
  message(STATUS "uintptr_t value considered YES ")
else()
  message(STATUS "uintptr_t value considered NO ")
endif()
if (HAVE_INTPTR_T)
  message(STATUS "HAVE_INTPTR_T 1: intptr_t defined in stdint.h... YES")
else()
  message(STATUS "intptr_t defined in stdint.h... NO")
  set(intptr_t "long long int" )
  message(STATUS "Setting #define intptr_t " ${intptr_t})
endif()
if (intptr_t)
  message(STATUS "intptr_t value considered YES ")
else()
  message(STATUS "intptr_t value considered NO ")
endif()

message(STATUS "ENABLE_DECOMPRESSION : " ${ENABLE_DECOMPRESSION})
if (ENABLE_DECOMPRESSION)
  #message(STATUS "In ENABLE_DECOMPRESSION setup: TRUE")
  # Zlib and ZSTD need to be found otherwise disable it
  if(NOT TARGET ZLIB::ZLIB)
    find_package(ZLIB)
  else()
    # Presumably in this case, the target has been found externally but set this flag just in case
    set(ZLIB_FOUND TRUE)
  endif()
  # This feels excessive, however perhaps better safe than sorry
  if(
    NOT (
      TARGET zstd::libzstd_shared OR
      TARGET zstd::libzstd_static OR
      TARGET libzstd_shared OR
      TARGET libzstd_static OR
      TARGET ZSTD::ZSTD
    )
  )
    find_package(zstd)
  else()
    # Presumably in this case, the target has been found externally but set this flag just in case
    set(zstd_FOUND TRUE)
  endif()
  # Unfortunately aliasing ZSTD::ZSTD to zstd::libzstd_shared/static can lead to problems for end-users, a variable
  # is used
  if(TARGET zstd::libzstd_shared)
    set(ZSTD_LIB zstd::libzstd_shared)
  elseif(TARGET zstd::libzstd_static)
    set(ZSTD_LIB zstd::libzstd_static)
  elseif(TARGET libzstd_shared)
    set(ZSTD_LIB libzstd_shared)
  elseif(TARGET libzstd_static)
    set(ZSTD_LIB libzstd_static)
  else()
    set(ZSTD_LIB ZSTD::ZSTD)
  endif()
  if (ZLIB_FOUND AND zstd_FOUND )
    set(HAVE_ZLIB TRUE)
    set(HAVE_ZLIB_H TRUE)
    set(HAVE_ZSTD TRUE)
    set(HAVE_ZSTD_H TRUE)
    set(BUILT_WITH_ZLIB_AND_ZSTD TRUE)
  endif()
  message(STATUS "Found libzstd           : ${zstd_FOUND}")
  message(STATUS "Found zlib              : ${ZLIB_FOUND}")
  message(STATUS "Build with zlib and zstd: ${BUILT_WITH_ZLIB_AND_ZSTD}")
else()
  message(STATUS "Build with zlib and zstd: NO")
endif ()

message(STATUS "CMAKE_SIZEOF_VOID_P ... : ${CMAKE_SIZEOF_VOID_P}")

#  DW_FWALLXX are gnu C++ options.
if (WALL)
  set(DW_FWALLXX -Wall -Wextra -Wno-unused-private-field -Wpointer-arith -Wmissing-declarations -Wcomment -Wformat -Wpedantic -Wuninitialized -Wshadow -Wno-long-long -Werror)
  set(DW_FWALL ${DW_FWALLXX} -Wpointer-arith -Wmissing-declarations -Wmissing-prototypes -Wdeclaration-after-statement -Wextra -Wcomment -Wformat -Wpedantic -Wuninitialized -Wno-long-long -Wshadow -Werror )
  message(STATUS "Compiler warning options... YES ${DW_FWALL}")
else()
  unset(DW_FWALL )
  message(STATUS "Compiler warning options... NO")
endif()
#if (LIBDWARF_STATIC)
#  set(DW_LIBDWARF_STATIC -DLIBDWARF_STATIC)
#else()
#  unset(DW_LIBDWARF_STATIC)
#endif()

configure_file(cmake/config.h.in config.h)

if(BUILD_NON_SHARED)
  set(DW_LIBDWARF_STATIC -DLIBDWARF_STATIC)
  set(BUILD_SHARED_LIBS NO)
else()
  unset(DW_LIBDWARF_STATIC)
  set(BUILD_SHARED_LIBS YES)
endif()

include(GNUInstallDirs)

add_subdirectory(src/lib/libdwarf)
add_subdirectory(doc)

if ( BUILD_DWARFDUMP )
  add_subdirectory(src/bin/dwarfdump)
endif()

if ( BUILD_DWARFEXAMPLE )
	add_subdirectory(src/bin/dwarfexample)
endif()

if ( BUILD_DWARFGEN )
  add_subdirectory(src/lib/libdwarfp)
  add_subdirectory(src/bin/dwarfgen)
endif()

if (DO_TESTING)
  enable_testing()
  add_subdirectory(test)
endif()

message(STATUS "Install prefix ... ${CMAKE_INSTALL_PREFIX}" )
# installation of libdwarf[p] has to be in
# src/lib/libdwarf[p]/CMakeLists.txt
# so that it works properly for cmake before cmake 3.13.

=== meson_options.txt ===

option('dwarfgen',
  type : 'boolean',
  value : false,
  description : 'enable dwarfgen compilation'
)

option('dwarfexample',
  type : 'boolean',
  value : false,
  description : 'enable dwarf examples compilation'
)

option('doc',
  type : 'boolean',
  value : false,
  description : 'build and install Doxygen documentation'
)

option('sanitize',
  type : 'boolean',
  value : false,
  description : 'compile and link with -fsanitize options'
)

option('wall',
  type : 'boolean',
  value : false,
  description : 'compile and link with compiler warning options'
)

option('decompression',
  type : 'boolean',
  value : true,
  description : 'compile and link with zlib and zstd decompression libraries'
)

=== debian/changelog ===
dwarfutils (1:0.11.1-1) unstable; urgency=medium

  * Upload to unstable

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 24 Mar 2025 08:54:16 +0100

dwarfutils (1:0.11.1-1~exp2) experimental; urgency=medium

  * Add python3 in the build dep for the tests

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 11 Mar 2025 09:23:38 +0100

dwarfutils (1:0.11.1-1~exp1) experimental; urgency=medium

  * New upstream release to use https://github.com/davea42/libdwarf-code
    which includes security fixes
    (Closes: #1065511)
    Bump epoch for this
  * Update of the homepage
  * Update of the watch link
  * Update lintian override info format in d/source/lintian-overrides
    on line 7, 17, 29-32.
  * Update standards version to 4.6.2, no changes needed.
  * Remove 00-spelling.patch - applied upstream
  * Add pkgconf in the build deps
  * Fix the doc paths

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 09 Mar 2025 08:43:50 +0100

dwarfutils (20210528-1) unstable; urgency=medium

  * New upstream release.
  * Upgrade to Standards-Version 4.6.0.
  * Drop 00-timezone.patch and 01-spelling.patch (fixed upstream).
  * Update years in debian/copyright.
  * Update symbols file.
  * Add patch 00-spelling.patch.

 -- Fabian Wolff <fabi.wolff@arcor.de>  Sat, 11 Sep 2021 16:03:21 +0200

dwarfutils (20201201-1) unstable; urgency=medium

  * New upstream release.
  * Update symbols file.
  * Upgrade to Standards-Version 4.5.1.
  * Update Vcs-Git and Vcs-Browser fields.
  * Add 00-timezone.patch to fix a test case failure caused by the precise
    output depending on the current time zone.
  * Add 01-spelling.patch to fix the spelling errors found by Lintian.
  * Update Lintian overrides.

 -- Fabian Wolff <fabi.wolff@arcor.de>  Sat, 26 Dec 2020 14:54:07 +0100

dwarfutils (20200825-1) unstable; urgency=medium

  * New upstream release (Closes: #963098).
  * Update symbols file.
  * Upgrade to debhelper compat level 13.
  * Remove trailing slash from Vcs-Git field in debian/control.

 -- Fabian Wolff <fabi.wolff@arcor.de>  Mon, 31 Aug 2020 14:36:01 +0200

dwarfutils (20200114-1) unstable; urgency=medium

  * New upstream release.
  * Make include-test more cross-test-friendly (thanks to Steve Langasek
    <steve.langasek@canonical.com> for this!) (Closes: #948605).
  * Update debian/copyright.
  * Upgrade to Standards-Version 4.5.0.
  * Update Lintian overrides.

 -- Fabian Wolff <fabi.wolff@arcor.de>  Sat, 01 Feb 2020 18:51:20 +0100

dwarfutils (20191104-1) unstable; urgency=medium

  * New upstream release.
  * Update symbols file.
  * Update comments in debian/source/lintian-overrides.

 -- Fabian Wolff <fabi.wolff@arcor.de>  Wed, 06 Nov 2019 21:52:10 +0100

dwarfutils (20191002-1) unstable; urgency=medium

  * New upstream release.
  * Upgrade to Standards-Version 4.4.1 (no changes).
  * Add run-test and mark tests as superficial.
  * Update symbols file.
  * Update copyright years in debian/copyright.
  * Add debian/missing-sources/ to add the source file for a test case.
  * Add debian/source/lintian-overrides to override unjustified Lintian
    tags about missing and prebuilt binaries (read the explanations
    provided in that file for details).

 -- Fabian Wolff <fabi.wolff@arcor.de>  Tue, 05 Nov 2019 18:52:33 +0100

dwarfutils (20190529-1) unstable; urgency=medium

  * New upstream release.
  * Upgrade to Standards-Version 4.4.0 in debian/control (no changes).
  * Remove 00-fix-flags.patch (fixed upstream).
  * Update symbols file.
  * Upgrade to debhelper compat level 12.
  * Update debian/rules.

 -- Fabian Wolff <fabi.wolff@arcor.de>  Sun, 25 Aug 2019 17:39:12 +0200

dwarfutils (20180809-1) unstable; urgency=medium

  * New upstream release.
  * Upgrade to Standards-Version 4.2.1 in debian/control (no changes).
  * Update debian/copyright.
  * Update package build scripts (the upstream build process changed).
  * Update symbols file.
  * Remove 01-fix-makefile.patch (fixed upstream).
  * Add 00-fix-flags.patch to fix the warnings reported by blhc.

 -- Fabian Wolff <fabi.wolff@arcor.de>  Wed, 29 Aug 2018 22:46:39 +0200

dwarfutils (20180527-1) unstable; urgency=medium

  * New upstream release (Closes: #880771).
  * Fix broken symlinks in the libdwarf1 and libdwarf-dev packages
    (Closes: #891366).
  * Upgrade to Standards-Version 4.1.4 in debian/control (no changes).
  * Upgrade to debhelper compat level 11.
  * Remove incorrect Multi-Arch: foreign annotation for the dwarfdump
    package in debian/control.
  * Refresh patch 01-fix-makefile.patch.
  * Update symbols file.
  * Delete trailing whitespace from debian/changelog in order to
    silence the file-contains-trailing-whitespace Lintian tag.
  * Enable rudimentary autopkgtest package testing.

 -- Fabian Wolff <fabi.wolff@arcor.de>  Fri, 01 Jun 2018 12:26:43 +0200

dwarfutils (20180129-1) unstable; urgency=medium

  * New upstream release (Closes: #880771).
  * Remove Daniel Stender from Uploaders field in debian/control
    (Closes: #882119).
  * Upgrade to Standards-Version 4.1.3 in debian/control (no changes).
  * Remove useless dh-autoreconf build dependency.
  * Update Vcs-Git and Vcs-Browser fields in debian/control.
  * Update 01-fix-makefile.patch.
  * Update symbols file.
  * Update debian/copyright.

 -- Fabian Wolff <fabi.wolff@arcor.de>  Sat, 17 Feb 2018 15:15:20 +0100

dwarfutils (20170709-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patch 01-fix-makefile.patch.
  * Remove patch 02-fix-CVE-2017-9998.patch (fixed upstream).
  * Update symbols file.

 -- Fabian Wolff <fabi.wolff@arcor.de>  Thu, 13 Jul 2017 21:01:23 +0200

dwarfutils (20170416-3) unstable; urgency=medium

  * Update debian/copyright.
  * Upgrade to Standards-Version 4.0.0 in debian/control (no changes).
  * Add patch 02-fix-CVE-2017-9998.patch to fix CVE-2017-9998
    (Closes: #866968).
  * Add override_dh_compress target in debian/rules to make sure the
    upstream changelog is compressed (Closes: #866155).



=== debian/control ===
Source: dwarfutils
Maintainer: Fabian Wolff <fabi.wolff@arcor.de>
Section: libs
Priority: optional
Build-Depends: debhelper-compat (= 13),
               libelf-dev,
               zlib1g-dev,
               pkgconf,
               python3
Standards-Version: 4.6.2
Homepage: https://github.com/davea42/libdwarf-code
Vcs-Git: https://salsa.debian.org/wolff/dwarfutils.git
Vcs-Browser: https://salsa.debian.org/wolff/dwarfutils

Package: dwarfdump
Architecture: any
Section: utils
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: utility to dump DWARF debug information from ELF objects
 Dwarfdump is an application that can print the DWARF debugging
 information of an ELF object file in a human-readable form. It can
 also be used to check and validate manipulated DWARF sections.
 .
 This utility is part of dwarfutils.

Package: libdwarf-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libdwarf1 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: library to consume and produce DWARF debug information
 The libdwarf package provides a library which allows
 reading/consuming and writing/producing of DWARF debugging
 information from object files, shared libraries, and executables.
 .
 This package contains developer resources for libdwarf. Install it if
 you want to develop software that uses the libdwarf API.
 .
 This library is part of dwarfutils.

Package: libdwarf1
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: library to consume and produce DWARF debug information (runtime)
 The libdwarf package provides a library which allows
 reading/consuming and writing/producing of DWARF debugging
 information from object files, shared libraries, and executables.
 .
 This package contains the runtime library. You should not have to
 install it manually.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode
# export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=autoconf

override_dh_auto_configure:
	dh_auto_configure -- --enable-shared --includedir=/usr/include

override_dh_install:
	mv debian/tmp/usr/include/libdwarf-1/* debian/tmp/usr/include/
	rmdir debian/tmp/usr/include/libdwarf-1/
	dh_install

=== debian/watch ===
version=4
https://github.com/davea42/libdwarf-code//tags .*/v?(\d.*).tar\.gz

## dwarfutils 20120410

=== debian/changelog ===
dwarfutils (20120410-2+deb7u2build0.16.04.1) xenial-security; urgency=medium

  * fake sync from Debian

 -- Tyler Hicks <tyhicks@canonical.com>  Mon, 31 Oct 2016 21:15:51 +0000

dwarfutils (20120410-2+deb7u2) wheezy-security; urgency=high

  * New maintainer.
  * Add patch CVE-2015-8538.patch to fix CVE-2015-8538 (Closes: #807817).
  * Add patch CVE-2015-8750.patch to fix CVE-2015-8750 (Closes: #813182).
  * Add patch CVE-2016-2050.patch to fix CVE-2016-2050.
  * Add patch CVE-2016-2091.patch to fix CVE-2016-2091 (Closes: #813148).
  * Add patch CVE-2016-5034.patch to fix CVE-2016-5034.
  * Add patch CVE-2016-5036.patch to fix CVE-2016-5036.
  * Add patch CVE-2016-5038.patch to fix CVE-2016-5038.
  * Add patch CVE-2016-5039.patch to fix CVE-2016-5039.
  * Add patch CVE-2016-5042.patch to fix CVE-2016-5042.

 -- Daniel Stender <stender@debian.org>  Wed, 19 Oct 2016 00:29:41 +0200

dwarfutils (20120410-2+deb7u1) wheezy-security; urgency=high

  * Specify "3.0 (quilt)" in debian/source/format to enforce clarity of
    patches.
  * CVE-2016-7510, CVE-2016-7511: Fix out-of-bounds read in range handling.

 -- Chris Lamb <lamby@debian.org>  Sat, 24 Sep 2016 13:18:41 +0200

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

#!/usr/bin/make -f

%:
	dh $@ --with quilt

override_dh_auto_build:
	# configure and build library
	cd libdwarf; ./configure --prefix=$(CURDIR)/debian/libdwarf-dev
	cd libdwarf; make
	# configure and build dwarfdump
	cd dwarfdump; ./configure --prefix=$(CURDIR)/debian/dwarfdump
	cd dwarfdump; make
	# configure and build dwarfdump2
	cd dwarfdump2; ./configure --prefix=$(CURDIR)/debian/dwarfdump2
	cd dwarfdump2; make
	dh_auto_build

override_dh_auto_clean:
	# configure and build library
	cd libdwarf; ./configure --prefix=$(CURDIR)/debian/libdwarf-dev
	cd libdwarf; make distclean
	# configure and build dwarfdump
	cd dwarfdump; ./configure --prefix=$(CURDIR)/debian/dwarfdump
	cd dwarfdump; make distclean
	# configure and build dwarfdump2
	cd dwarfdump2; ./configure --prefix=$(CURDIR)/debian/dwarfdump2
	cd dwarfdump2; make distclean
	dh_auto_clean

override_dh_auto_install:
	cp libdwarf/libdwarf.a $(CURDIR)/debian/libdwarf-dev/usr/lib/
	cp libdwarf/dwarf.h libdwarf/libdwarf.h $(CURDIR)/debian/libdwarf-dev/usr/include/
	cp libdwarf/*.pdf $(CURDIR)/debian/libdwarf-dev/usr/share/doc/libdwarf-dev
	cp libdwarf/[NR]* $(CURDIR)/debian/libdwarf-dev/usr/share/doc/libdwarf-dev
	/bin/gzip -9 < libdwarf/ChangeLog > $(CURDIR)/debian/libdwarf-dev/usr/share/doc/libdwarf-dev/changelog.gz
	/bin/gzip -9 < libdwarf/ChangeLog2008 > $(CURDIR)/debian/libdwarf-dev/usr/share/doc/libdwarf-dev/changelog2008.gz
	/bin/gzip -9 < libdwarf/ChangeLog2007 > $(CURDIR)/debian/libdwarf-dev/usr/share/doc/libdwarf-dev/changelog2007.gz
	/bin/gzip -9 < libdwarf/ChangeLog2006 > $(CURDIR)/debian/libdwarf-dev/usr/share/doc/libdwarf-dev/changelog2006.gz
	cp dwarfexample/*  $(CURDIR)/debian/libdwarf-dev/usr/share/doc/libdwarf-dev/examples/
	cp dwarfdump2/dwarfdump $(CURDIR)/debian/dwarfdump/usr/bin/
	/bin/gzip -9 < dwarfdump2/dwarfdump.1 > $(CURDIR)/debian/dwarfdump/usr/share/man/man1/dwarfdump.1.gz
	/bin/gzip -9 < dwarfdump/README > $(CURDIR)/debian/dwarfdump/usr/share/doc/dwarfdump/README.gz
	/bin/gzip -9 < dwarfdump/ChangeLog > $(CURDIR)/debian/dwarfdump/usr/share/doc/dwarfdump/changelog.gz
	cp dwarfdump2/dwarfdump.conf $(CURDIR)/debian/dwarfdump/usr/share/doc/dwarfdump/examples/dwarfdump.conf
	dh_auto_install

override_dh_install:
	# everything is installed

override_dh_auto_test:
	# dwarfutils does not provide a testsuite

## dwarfutils 20161124

=== debian/changelog ===
dwarfutils (20161124-1+deb9u1) stretch; urgency=medium

  * Add patch 02-fix-CVE-2017-9052.patch to fix CVE-2017-9052 and
    CVE-2017-9055 (Closes: #864064).
  * Add patch 03-fix-CVE-2017-9053.patch to fix CVE-2017-9053.
  * Add patch 04-fix-CVE-2017-9054.patch to fix CVE-2017-9054.
  * Add patch 05-fix-CVE-2017-9998.patch to fix CVE-2017-9998
    (Closes: #866968).

 -- Fabian Wolff <fabi.wolff@arcor.de>  Sat, 15 Jul 2017 12:50:56 +0200

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,20 @@
 Source: dwarfutils
 Maintainer: Fabian Wolff <fabi.wolff@arcor.de>
+Uploaders: Daniel Stender <stender@debian.org>
 Section: libs
 Priority: optional
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: debhelper (>= 9),
+               dh-autoreconf,
                libelf-dev,
-               zlib1g-dev,
-               pkgconf,
-               python3
-Standards-Version: 4.6.2
-Homepage: https://github.com/davea42/libdwarf-code
-Vcs-Git: https://salsa.debian.org/wolff/dwarfutils.git
-Vcs-Browser: https://salsa.debian.org/wolff/dwarfutils
+               zlib1g-dev
+Standards-Version: 3.9.8
+Homepage: https://www.prevanders.net/dwarf.html
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/dwarfutils.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/dwarfutils.git
 
 Package: dwarfdump
 Architecture: any
+Multi-Arch: foreign
 Section: utils
 Depends: ${shlibs:Depends},
          ${misc:Depends}

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode
# export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --parallel --with autoreconf

override_dh_auto_configure:
	dh_auto_configure -- --enable-shared

override_dh_install:
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/
	cp libdwarf/libdwarf.a libdwarf/libdwarf.so.* \
		debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/
	cd debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/ && \
		ln -s libdwarf.so.* libdwarf.so
	dh_install

## dwarfutils 20170709

=== dwarfdump/CMakeLists.txt ===
include(configure.cmake)

add_library(esb_and_tsearchbal OBJECT esb.c dwarf_tsearchbal.c)

set_folder(esb_and_tsearchbal dwarfdump)

target_include_directories(esb_and_tsearchbal PRIVATE
    $<TARGET_PROPERTY:${dwarf-target},INTERFACE_INCLUDE_DIRECTORIES>)

msvc_posix(esb_and_tsearchbal)

set_source_group(SOURCES "Source Files" addrmap.c checkutil.c dwarfdump.c dwconf.c helpertree.c 
	glflags.c
	macrocheck.c print_abbrevs.c print_aranges.c print_debugfission.c print_die.c 
	print_dnames.c print_frames.c  print_gdbindex.c
	print_lines.c print_locs.c print_macro.c print_macros.c print_pubnames.c print_ranges.c print_reloc.c 
	print_sections.c  print_section_groups.c print_static_funcs.c  print_static_vars.c print_strings.c print_types.c print_weaknames.c  
	sanitized.c section_bitmaps.c strstrnocase.c uri.c dwgetopt.c makename.c naming.c common.c $<TARGET_OBJECTS:esb_and_tsearchbal>)
	
set_source_group(HEADERS "Header Files" checkutil.h common.h dwconf.h dwgetopt.h esb.h glflags.h globals.h macrocheck.h 
	makename.h dwarf_tsearch.h print_frames.h section_bitmaps.h uri.h)

set_source_group(CONFIGURATION_FILES "Configuration Files" configure.cmake config.h.in.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)
	
set_source_group(TAG_GENERATED "Generated Files" tmp-tt-table.c tmp-ta-table.c tmp-ta-ext-table.c tmp-tt-ext-table.c)

add_executable(dwarfdump ${SOURCES} ${HEADERS} ${TAG_GENERATED} ${CONFIGURATION_FILES})

set_folder(dwarfdump dwarfdump)

target_compile_options(dwarfdump PRIVATE ${dwfwall})

target_compile_definitions(dwarfdump PRIVATE "CONFPREFIX=${CMAKE_INSTALL_PREFIX}/lib")

target_link_libraries(dwarfdump PRIVATE ${dwarf-target} ${dwfzlib}) 

# We need this as naming.o has external references we cannot have
# in the tree builds.
configure_file(naming.c trivial_naming.c COPYONLY)

set_source_files_properties(trivial_naming.c PROPERTIES COMPILE_DEFINITIONS TRIVIAL_NAMING)

set(TAG_TREE_SOURCES tag_tree.c tag_common.c common.c makename.c trivial_naming.c dwgetopt.c dwarf_tsearchbal.c)

add_executable(tag_tree_build ${TAG_TREE_SOURCES})

set_folder(tag_tree_build dwarfdump/generators)

target_link_libraries(tag_tree_build PRIVATE ${dwarf-target})

set(TAG_ATTR_SOURCES tag_attr.c tag_common.c common.c makename.c trivial_naming.c dwgetopt.c dwarf_tsearchbal.c)
 
add_executable(tag_attr_build ${TAG_ATTR_SOURCES}) 

set_folder(tag_attr_build dwarfdump/generators)

target_link_libraries(tag_attr_build PRIVATE ${dwarf-target})

# Plain GNU C dash E does not work on a .list, 
# so copy to a .c name to run
# the following four table creations.
set(TAG_LIST_FILES tag_tree.list tag_attr.list tag_attr_ext.list tag_tree_ext.list)
set(TAG_SWITCH -s -s -e -e)
set(TAG_TOOL tag_tree_build tag_attr_build tag_attr_build tag_tree_build)
foreach(i RANGE 0 3)
    list(GET TAG_GENERATED ${i} generatedFile)
    list(GET TAG_LIST_FILES ${i} listFile)
    list(GET TAG_SWITCH ${i} tagSwitch)
    list(GET TAG_TOOL ${i} tagTool)
    
    math(EXPR j "${i} + 1")
    
    set(tmpSouce tmp-t${j})
	set(tmpDest tmp-tag-build${j}.tmp)
    
    configure_file(${listFile} ${tmpSouce}.c COPYONLY)
    
    add_custom_command(OUTPUT ${generatedFile}
		COMMAND ${CMAKE_C_COMPILER} -E -I${CMAKE_CURRENT_SOURCE_DIR}/../libdwarf -DCONFPREFIX=${CMAKE_INSTALL_PREFIX}/lib ${tmpSouce}.c > ${tmpDest}
        COMMAND ${tagTool} ${tagSwitch} -i ${tmpDest} -o ${generatedFile}
        DEPENDS ${tagTool} ${listFile})
endforeach()
	
set_source_group(TESTESB_SOURCES "Source Files" esb.c testesb.c)

add_executable(testesb ${TESTESB_SOURCES})

set_folder(testesb dwarfdump/tests)

target_include_directories(testesb PRIVATE
    $<TARGET_PROPERTY:${dwarf-target},INTERFACE_INCLUDE_DIRECTORIES>)

add_test(NAME test COMMAND testesb)

set_source_group(GETOPTEST_SOURCES "Source Files" getopttest.c dwgetopt.c)

add_executable(getopttest ${GETOPTEST_SOURCES})

set_folder(getopttest dwarfdump/tests)

add_test(NAME getopttest COMMAND getopttest)

add_executable(getopttestnat ${GETOPTEST_SOURCES})

set_folder(getopttestnat dwarfdump/tests)

if(UNIX)
	target_compile_definitions(getopttestnat PRIVATE GETOPT_FROM_SYSTEM)
endif()

foreach(i 1 2 3 5 6 7 8)
	add_test(NAME getopttestnat${i} COMMAND getopttestnat -c ${i})
endforeach()
	
set_source_group(SELFHELPERTREE_SOURCES "Source Files" helpertree.c)

add_executable(selfhelpertree ${SELFHELPERTREE_SOURCES} $<TARGET_OBJECTS:esb_and_tsearchbal>)

set_folder(selfhelpertree dwarfdump/tests)

target_compile_definitions(selfhelpertree PRIVATE SELFTEST)

target_include_directories(selfhelpertree PRIVATE
    $<TARGET_PROPERTY:${dwarf-target},INTERFACE_INCLUDE_DIRECTORIES>)

add_test(NAME selfhelpertree COMMAND selfhelpertree)

#doesn't compile	
#set_source_group(SELFMC_SOURCES "Source Files" macrocheck.c $<TARGET_OBJECTS:esb_and_tsearchbal>)
#
#add_executable(selfmc ${SELFMC_SOURCES})
#
# set_folder(selfmc dwarfdump/tests)
#
#target_compile_definitions(selfmc PRIVATE SELFTEST)
#
#target_include_directories(selfmc PRIVATE
#    $<TARGET_PROPERTY:${dwarf-target},INTERFACE_INCLUDE_DIRECTORIES>)
#
#add_test(NAME selfmc COMMAND selfmc)
	
set_source_group(SELFESB_SOURCES "Source Files" esb.c)

add_executable(selfesb ${SELFESB_SOURCES})

set_folder(selfesb dwarfdump/tests)

target_compile_definitions(selfesb PRIVATE SELFTEST)

target_include_directories(selfesb PRIVATE
    $<TARGET_PROPERTY:${dwarf-target},INTERFACE_INCLUDE_DIRECTORIES>)

add_test(NAME selfesb COMMAND selfesb)

if(${CMAKE_SIZEOF_VOID_P} EQUAL 8)
	set(SUFFIX 64)
endif()
set(LIBDIR lib${SUFFIX})
set(BINDIR bin${SUFFIX})

install(TARGETS dwarfdump DESTINATION
	RUNTIME DESTINATION ${BINDIR}		
	LIBRARY DESTINATION ${LIBDIR}
	ARCHIVE DESTINATION ${LIBDIR})

install(FILES dwarfdump.conf DESTINATION ${LIBDIR})

install(FILES dwarfdump.1 DESTINATION share/man/man1)

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,11 @@
 Uploaders: Daniel Stender <stender@debian.org>
 Section: libs
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 10),
                dh-autoreconf,
                libelf-dev,
                zlib1g-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: https://www.prevanders.net/dwarf.html
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/dwarfutils.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/dwarfutils.git

## dwarfutils 20180129

=== dwarfdump/CMakeLists.txt ===
--- 
+++ 
@@ -40,7 +40,7 @@
 
 set_source_files_properties(trivial_naming.c PROPERTIES COMPILE_DEFINITIONS TRIVIAL_NAMING)
 
-set(TAG_TREE_SOURCES tag_tree.c tag_common.c common.c makename.c trivial_naming.c dwgetopt.c dwarf_tsearchbal.c)
+set(TAG_TREE_SOURCES tag_tree.c tag_common.c common.c makename.c trivial_naming.c dwgetopt.c dwarf_tsearchbal.c sanitized.c esb.c)
 
 add_executable(tag_tree_build ${TAG_TREE_SOURCES})
 
@@ -48,7 +48,7 @@
 
 target_link_libraries(tag_tree_build PRIVATE ${dwarf-target})
 
-set(TAG_ATTR_SOURCES tag_attr.c tag_common.c common.c makename.c trivial_naming.c dwgetopt.c dwarf_tsearchbal.c)
+set(TAG_ATTR_SOURCES tag_attr.c tag_common.c common.c makename.c trivial_naming.c dwgetopt.c dwarf_tsearchbal.c sanitized.c esb.c)
  
 add_executable(tag_attr_build ${TAG_ATTR_SOURCES})

=== dwarfexample/CMakeLists.txt ===
include(configure.cmake)

set_source_group(SIMPLE_READER_SOURCES "Source Files" simplereader.c)

set_source_group(CONFIGURATION_FILES "Configuration Files" configure.cmake config.h.in.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

add_executable(simplereader ${SIMPLE_READER_SOURCES} ${SIMPLE_READER_HEADERS} ${CONFIGURATION_FILES})

set_folder(simplereader dwarfexample)

target_compile_definitions(simplereader PRIVATE CONFPREFIX={CMAKE_INSTALL_PREFIX}/lib)

target_link_libraries(simplereader PRIVATE ${dwarf-target} ${dwfzlib})

set_source_group(FRAME1_SOURCES "Source Files" frame1.c)

add_executable(frame1 ${FRAME1_SOURCES} ${FRAME1_HEADERS} ${CONFIGURATION_FILES})

set_folder(frame1 dwarfexample)

target_compile_definitions(frame1 PRIVATE CONFPREFIX={CMAKE_INSTALL_PREFIX}/lib)

target_link_libraries(frame1 PRIVATE ${dwarf-target} ${dwfzlib})

=== libdwarf/CMakeLists.txt ===
include(configure.cmake)

set_source_group(SOURCES "Source Files" dwarf_abbrev.c dwarf_alloc.c dwarf_arange.c dwarf_die_deliv.c dwarf_dnames.c dwarf_dsc.c dwarf_elf_access.c dwarf_error.c 
dwarf_form.c dwarf_frame.c dwarf_frame2.c dwarf_frame3.c dwarf_funcs.c dwarf_gdbindex.c dwarf_global.c dwarf_groups.c dwarf_harmless.c dwarf_init_finish.c dwarf_leb.c 
dwarf_line.c dwarf_loc.c dwarf_macro.c dwarf_macro5.c dwarf_original_elf_init.c dwarf_pubtypes.c dwarf_query.c dwarf_ranges.c dwarf_string.c dwarf_tied.c 
dwarf_tsearchhash.c dwarf_types.c dwarf_util.c dwarf_vars.c dwarf_weaks.c dwarf_xu_index.c dwarf_print_lines.c malloc_check.c pro_alloc.c pro_arange.c 
pro_die.c pro_encode_nm.c pro_error.c pro_expr.c pro_finish.c pro_forms.c pro_funcs.c pro_frame.c pro_init.c pro_line.c pro_reloc.c pro_reloc_stream.c 
pro_reloc_symbolic.c pro_pubnames.c pro_section.c pro_types.c pro_vars.c pro_macinfo.c pro_weaks.c)

set_source_group(HEADERS "Header Files" dwarf.h dwarf_abbrev.h dwarf_alloc.h dwarf_arange.h dwarf_base_types.h dwarf_die_deliv.h dwarf_dnames.h dwarf_dsc.h 
dwarf_elf_access.h dwarf_error.h dwarf_frame.h dwarf_funcs.h dwarf_gdbindex.h dwarf_global.h dwarf_harmless.h dwarf_incl.h dwarf_line.h dwarf_loc.h 
dwarf_macro.h dwarf_macro5.h dwarf_opaque.h dwarf_reloc_arm.h dwarf_reloc_mips.h dwarf_reloc_ppc.h dwarf_reloc_ppc64.h dwarf_reloc_x86_64.h dwarf_tsearch.h 
dwarf_types.h dwarf_util.h dwarf_vars.h dwarf_weaks.h dwarf_xu_index.h dwgetopt.h libdwarfdefs.h malloc_check.h pro_alloc.h pro_arange.h pro_die.h 
pro_encode_nm.h pro_error.h pro_expr.h pro_frame.h pro_incl.h pro_line.h pro_macinfo.h pro_opaque.h pro_reloc.h pro_reloc_stream.h pro_reloc_symbolic.h 
pro_section.h pro_types.h pro_util.h)

set_source_group(GENNAMES_SOURCES "Source Files" gennames.c dwgetopt.c dwarf.h)

set_source_group(CONFIGURATION_FILES "Configuration Files" configure.cmake config.h.in.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

add_executable(gennames ${GENNAMES_SOURCES})

set_folder(gennames libdwarf/generators)

msvc_posix(gennames)

set(GENNAMES_OUTPUT dwarf_names.c dwarf_names.h dwarf_names_enum.h dwarf_names_new.h)

add_custom_command(OUTPUT ${GENNAMES_OUTPUT}
    COMMAND gennames ${dwarf_namestable} -i ${CMAKE_CURRENT_SOURCE_DIR} -o .
    DEPENDS gennames libdwarf.h.in)
	
list(LENGTH DWARF_TARGETS targetCount)
math(EXPR targetCount "${targetCount} - 1")
foreach(i RANGE ${targetCount})
	list(GET DWARF_TARGETS ${i} target)
	list(GET DWARF_TYPES ${i} type)
	add_library(${target} ${type} ${SOURCES} ${HEADERS} ${GENNAMES_OUTPUT} ${CONFIGURATION_FILES})

	set_folder(${target} libdwarf)

	target_include_directories(${target} PUBLIC ${LIBELF_INCLUDE_DIRS})

	msvc_posix(${target})

	target_link_libraries(${target} PUBLIC ${LIBELF_LIBRARIES})
	
	set_target_properties(${target} PROPERTIES OUTPUT_NAME dwarf)

	set(SUFFIX $<$<EQUAL:${CMAKE_SIZEOF_VOID_P},8>:64>)
	set(LIBDIR lib${SUFFIX})
	set(BINDIR bin${SUFFIX})

	install(TARGETS ${target}
		RUNTIME DESTINATION ${BINDIR}		
		LIBRARY DESTINATION ${LIBDIR}
		ARCHIVE DESTINATION ${LIBDIR})
endforeach()

if(UNIX AND shared)
	target_link_libraries(dwarf-shared PUBLIC z)
endif()
		
if(UNIX)

#
# The following are very SGI-centric
# psroff is just a troff formatter.
# the .mm files are in ATT/USL/USG mm form.
# Calling it pdfbld or bldpdf is arbitrary, so allow both.

#Oriented to using gsroff now.
set(TROFF /usr/bin/groff)
#set(TROFFDEV "-T ps")
set(TROFFDEV)
set(PSTOPDF /usr/bin/ps2pdf)
set(BUILD_BASE .)
# pr expands tabs to spaces: this avoids problems with tab
# interpretation

# The warning about 'cant break line' is a too-long line used
# in the table of contents.
# All pr does here is change each tab to spaces.
# Ignore the warning (and those like it).
add_custom_command(OUTPUT libdwarf2.1.pdf
    COMMAND -pr -t -e ${BUILD_BASE}/libdwarf2.1.mm | tbl | ${TROFF} ${TROFFDEV} -mm >libdwarf2.1.ps
    COMMAND ${PSTOPDF} libdwarf2.1.ps ${CMAKE_CURRENT_BINARY_DIR}/libdwarf2.1.pdf
    DEPENDS ${BUILD_BASE}/libdwarf2.1.mm)
    
add_custom_command(OUTPUT libdwarf2p.1.pdf
    COMMAND -pr -t -e ${BUILD_BASE}/libdwarf2p.1.mm | tbl | ${TROFF} ${TROFFDEV} -mm >libdwarf2p.1.ps
    COMMAND ${PSTOPDF} libdwarf2p.1.ps ${CMAKE_CURRENT_BINARY_DIR}/libdwarf2p.1.pdf
    DEPENDS ${BUILD_BASE}/libdwarf2p.1.mm)
    
add_custom_command(OUTPUT mips_extensions.pdf
    COMMAND -pr ${TROFFDEV} -e ${BUILD_BASE}/mips_extensions.mm | tbl | ${TROFF} ${TROFFDEV} -mm >mips_extensions.ps
    COMMAND ${PSTOPDF} mips_extensions.ps ${CMAKE_CURRENT_BINARY_DIR}/mips_extensions.pdf
    DEPENDS ${BUILD_BASE}/mips_extensions.mm)
    
add_custom_target(pdfbld
    DEPENDS libdwarf2.1.pdf libdwarf2p.1.pdf mips_extensions.pdf)

set_folder(pdfbld libdwarf/documentation)
    
add_custom_target(bldpdf
    DEPENDS pdfbld)

set_folder(bldpdf libdwarf/documentation)
    
add_custom_target(docbld
    DEPENDS pdfbld)

set_folder(docbld libdwarf/documentation)

endif()

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,14 @@
 Source: dwarfutils
 Maintainer: Fabian Wolff <fabi.wolff@arcor.de>
-Uploaders: Daniel Stender <stender@debian.org>
 Section: libs
 Priority: optional
 Build-Depends: debhelper (>= 10),
-               dh-autoreconf,
                libelf-dev,
                zlib1g-dev
-Standards-Version: 4.0.0
+Standards-Version: 4.1.3
 Homepage: https://www.prevanders.net/dwarf.html
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/dwarfutils.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/dwarfutils.git
+Vcs-Git: https://salsa.debian.org/wolff-guest/dwarfutils.git/
+Vcs-Browser: https://salsa.debian.org/wolff-guest/dwarfutils
 
 Package: dwarfdump
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
-	dh $@ --parallel --with autoreconf
+	dh $@ --with autoreconf
 
 override_dh_auto_configure:
 	dh_auto_configure -- --enable-shared
@@ -18,3 +18,6 @@
 	cd debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/ && \
 		ln -s libdwarf.so.* libdwarf.so
 	dh_install
+
+override_dh_compress:
+	dh_compress usr/share/doc/dwarfdump/ChangeLog

## dwarfutils 20180527

=== debian/control ===
--- 
+++ 
@@ -2,17 +2,16 @@
 Maintainer: Fabian Wolff <fabi.wolff@arcor.de>
 Section: libs
 Priority: optional
-Build-Depends: debhelper (>= 10),
+Build-Depends: debhelper (>= 11),
                libelf-dev,
                zlib1g-dev
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
 Homepage: https://www.prevanders.net/dwarf.html
 Vcs-Git: https://salsa.debian.org/wolff-guest/dwarfutils.git/
 Vcs-Browser: https://salsa.debian.org/wolff-guest/dwarfutils
 
 Package: dwarfdump
 Architecture: any
-Multi-Arch: foreign
 Section: utils
 Depends: ${shlibs:Depends},
          ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
-	dh $@ --with autoreconf
+	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- --enable-shared
@@ -18,6 +18,3 @@
 	cd debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/ && \
 		ln -s libdwarf.so.* libdwarf.so
 	dh_install
-
-override_dh_compress:
-	dh_compress usr/share/doc/dwarfdump/ChangeLog

## dwarfutils 20180809

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.2)

project(libdwarf)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

include(LibdwarfMacros)

# view folders on supported IDEs
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

# used when finding libelf
set_property(GLOBAL PROPERTY FIND_LIBRARY_USE_LIB64_PATHS TRUE)

# this project has tests
enable_testing()

# always include project's folder to includes
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_INCLUDE_CURRENT_DIR_IN_INTERFACE ON)

find_package(LibElf REQUIRED)

list(APPEND CMAKE_REQUIRED_INCLUDES ${LIBELF_INCLUDE_DIRS})

include(configure.cmake)

if(nonshared)
	set(DWARF_TARGETS dwarf-static)
	set(DWARF_TYPES STATIC)
	set(dwarf-target dwarf-static)
endif()
if(shared)
	list(APPEND DWARF_TARGETS dwarf-shared)
	list(APPEND DWARF_TYPES SHARED)
	set(dwarf-target dwarf-shared)
endif()

add_subdirectory(libdwarf)
add_subdirectory(dwarfexample)
add_subdirectory(dwarfdump)
add_subdirectory(dwarfgen)

add_custom_target(dd
	DEPENDS ${DWARF_TARGETS} dwarfdump)

=== dwarfdump/CMakeLists.txt ===
--- 
+++ 
@@ -10,14 +10,17 @@
 msvc_posix(esb_and_tsearchbal)
 
 set_source_group(SOURCES "Source Files" addrmap.c checkutil.c dwarfdump.c dwconf.c helpertree.c 
-	glflags.c
+	glflags.c command_options.c compiler_info.c
 	macrocheck.c print_abbrevs.c print_aranges.c print_debugfission.c print_die.c 
 	print_dnames.c print_frames.c  print_gdbindex.c
 	print_lines.c print_locs.c print_macro.c print_macros.c print_pubnames.c print_ranges.c print_reloc.c 
+	print_str_offsets.c
 	print_sections.c  print_section_groups.c print_static_funcs.c  print_static_vars.c print_strings.c print_types.c print_weaknames.c  
 	sanitized.c section_bitmaps.c strstrnocase.c uri.c dwgetopt.c makename.c naming.c common.c $<TARGET_OBJECTS:esb_and_tsearchbal>)
 	
-set_source_group(HEADERS "Header Files" checkutil.h common.h dwconf.h dwgetopt.h esb.h glflags.h globals.h macrocheck.h 
+set_source_group(HEADERS "Header Files" checkutil.h common.h dwconf.h
+  command_options.h compiler_info.h
+	dwgetopt.h esb.h glflags.h globals.h macrocheck.h defined_types.h
 	makename.h dwarf_tsearch.h print_frames.h section_bitmaps.h uri.h)
 
 set_source_group(CONFIGURATION_FILES "Configuration Files" configure.cmake config.h.in.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

=== libdwarf/CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,7 @@
 set_source_group(SOURCES "Source Files" dwarf_abbrev.c dwarf_alloc.c dwarf_arange.c dwarf_die_deliv.c dwarf_dnames.c dwarf_dsc.c dwarf_elf_access.c dwarf_error.c 
 dwarf_form.c dwarf_frame.c dwarf_frame2.c dwarf_frame3.c dwarf_funcs.c dwarf_gdbindex.c dwarf_global.c dwarf_groups.c dwarf_harmless.c dwarf_init_finish.c dwarf_leb.c 
 dwarf_line.c dwarf_loc.c dwarf_macro.c dwarf_macro5.c dwarf_original_elf_init.c dwarf_pubtypes.c dwarf_query.c dwarf_ranges.c dwarf_string.c dwarf_tied.c 
+dwarf_str_offsets.c
 dwarf_tsearchhash.c dwarf_types.c dwarf_util.c dwarf_vars.c dwarf_weaks.c dwarf_xu_index.c dwarf_print_lines.c malloc_check.c pro_alloc.c pro_arange.c 
 pro_die.c pro_encode_nm.c pro_error.c pro_expr.c pro_finish.c pro_forms.c pro_funcs.c pro_frame.c pro_init.c pro_line.c pro_reloc.c pro_reloc_stream.c 
 pro_reloc_symbolic.c pro_pubnames.c pro_section.c pro_types.c pro_vars.c pro_macinfo.c pro_weaks.c)
@@ -10,6 +11,7 @@
 set_source_group(HEADERS "Header Files" dwarf.h dwarf_abbrev.h dwarf_alloc.h dwarf_arange.h dwarf_base_types.h dwarf_die_deliv.h dwarf_dnames.h dwarf_dsc.h 
 dwarf_elf_access.h dwarf_error.h dwarf_frame.h dwarf_funcs.h dwarf_gdbindex.h dwarf_global.h dwarf_harmless.h dwarf_incl.h dwarf_line.h dwarf_loc.h 
 dwarf_macro.h dwarf_macro5.h dwarf_opaque.h dwarf_reloc_arm.h dwarf_reloc_mips.h dwarf_reloc_ppc.h dwarf_reloc_ppc64.h dwarf_reloc_x86_64.h dwarf_tsearch.h 
+dwarf_str_offsets.h
 dwarf_types.h dwarf_util.h dwarf_vars.h dwarf_weaks.h dwarf_xu_index.h dwgetopt.h libdwarfdefs.h malloc_check.h pro_alloc.h pro_arange.h pro_die.h 
 pro_encode_nm.h pro_error.h pro_expr.h pro_frame.h pro_incl.h pro_line.h pro_macinfo.h pro_opaque.h pro_reloc.h pro_reloc_stream.h pro_reloc_symbolic.h 
 pro_section.h pro_types.h pro_util.h)

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper (>= 11),
                libelf-dev,
                zlib1g-dev
-Standards-Version: 4.1.4
+Standards-Version: 4.2.1
 Homepage: https://www.prevanders.net/dwarf.html
 Vcs-Git: https://salsa.debian.org/wolff-guest/dwarfutils.git/
 Vcs-Browser: https://salsa.debian.org/wolff-guest/dwarfutils

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode
# export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/buildflags.mk
export CFLAGS_FOR_BUILD = $(CFLAGS)
export CPPFLAGS_FOR_BUILD = $(CPPFLAGS)
export LDFLAGS_FOR_BUILD = $(LDFLAGS)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --enable-shared

override_dh_missing:
	dh_missing --list-missing

=== debian/tests/control ===
Tests: include-test
Depends: @, build-essential
